// -*- c++ -*-
// Generated by gmmproc 2.45.3 -- DO NOT MODIFY!
#ifndef _GTKMM_TEAROFFMENUITEM_H
#define _GTKMM_TEAROFFMENUITEM_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* $Id: tearoffmenuitem.hg,v 1.1 2003/01/21 13:40:40 murrayc Exp $ */


/* tearoffmenuitem.h
 *
 * Copyright (C) 1998-2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/menuitem.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkTearoffMenuItem GtkTearoffMenuItem;
typedef struct _GtkTearoffMenuItemClass GtkTearoffMenuItemClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class TearoffMenuItem_Class; } // namespace Gtk
namespace Gtk
{

/** A special Gtk::MenuItem which is used to tear off and reattach its menu.
 * When its menu is shown normally, the Gtk::TearoffMenuItem is drawn as a dotted line indicating that the menu can be torn off. Activating it causes its menu to be torn off and displayed in its own window.
 * When its menu is shown as a tearoff menu, the Gtk::TearoffMenuItem is drawn as a dotted line which has a left pointing arrow graphic indicating that the tearoff menu can be reattached. Activating it will erase the tearoff menu window.
 * @ingroup Widgets
 * @ingroup Menus
 */

class TearoffMenuItem : public MenuItem
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef TearoffMenuItem CppObjectType;
  typedef TearoffMenuItem_Class CppClassType;
  typedef GtkTearoffMenuItem BaseObjectType;
  typedef GtkTearoffMenuItemClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~TearoffMenuItem();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class TearoffMenuItem_Class;
  static CppClassType tearoffmenuitem_class_;

  // noncopyable
  TearoffMenuItem(const TearoffMenuItem&);
  TearoffMenuItem& operator=(const TearoffMenuItem&);

protected:
  explicit TearoffMenuItem(const Glib::ConstructParams& construct_params);
  explicit TearoffMenuItem(GtkTearoffMenuItem* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GtkTearoffMenuItem*       gobj()       { return reinterpret_cast<GtkTearoffMenuItem*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GtkTearoffMenuItem* gobj() const { return reinterpret_cast<GtkTearoffMenuItem*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:
  TearoffMenuItem();

#ifndef GTKMM_DISABLE_DEPRECATED

  /** @deprecated This method was apparently not useful and will be removed in a later gtkmm version, due to changes in GTK+.
   */
  bool is_torn_off() const;
#endif // GTKMM_DISABLE_DEPRECATED


};

} /* namespace Gtk */


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::TearoffMenuItem
   */
  Gtk::TearoffMenuItem* wrap(GtkTearoffMenuItem* object, bool take_copy = false);
} //namespace Glib


#endif /* _GTKMM_TEAROFFMENUITEM_H */

